#!/usr/bin/env python
# coding: utf-8

import logging
from intelliw.core.pipeline import Pipeline
from intelliw.utils.logger import get_logger

logger = get_logger()


class Infer:
    def __init__(self, path, response_addr=None, perodic_interval=-1):
        # '/root/packages/car_recognize' , None, 10
        # './examples/lightgbm', -1
        self.pipeline = Pipeline(response_addr, perodic_interval)
        self.pipeline.importmodel(path)

    def infer(self, data, func='infer'):
        return self.pipeline.infer(data, func)

    def perodic_callback(self):
        self.pipeline.perodic_callback_infer()
          